/*
#define _REENTRANT
*/
#include <thread.h>
#include <an.h>

#define STR_LEN	512

typedef struct PARAMS {
	char *para_file, *result_file ;

	/* discretisation and system size parameters */
	int dx, dy, dz, dt ;
	int lx, ly, lt, lz_min, lz_max ;
	int subpd ;	/* subpixel disparity levels */
	int xs, ys, zs, ts, xys, xyzs ;

	int loop ;	/* loop number for solving simultaneous equations */
	int tintv ;	/* time interval for displaying the result */
	double delta ;	/* delta for convergence judgemenet */

	/* file names of stereo images */
	char fnl[STR_LEN], fnr[STR_LEN] ;

	/* for external stimulus and initial conditions */
	double mu_es, mu_ini, tht ;

	/* reaction-diffusion parameters */
	double Du, Dv, a0, a1, a2, b, eps ;
	double Cux, Cuy, Cuz, Cvx, Cvy, Cvz ;
	double pu, pv ;

	/* switch of u and v for data save */
	int sw_u, sw_v ;

	/* switch for interpolation in disparity undefined areas */
	int sw_ip ;

	/* number of threads */
	int nthr ;
} PARAMS ;

typedef struct VARS {
	/* stereo images and disparity map */
	unsigned char **image_left, **image_right, **dpmap ;

	/* reaction-diffusion
		ou, ov : activator and inhibitor
		es : external stimulus
		d : temporal variable
	*/
	double ***ou, ***ov, ***nu, ***nv, ***du, ***dv ;
	float ***es, ***es_sub ;
} VARS ;

typedef struct PARAMS_PTH {
	PARAMS ps ;
	VARS vs ;

	int lo, hi, fl ;
	double sum_dif ;
	thread_t tid ;

	sema_t start, stop ;
} PARAMS_PTH ;

