#include <stdio.h>
#include <stdlib.h>
#include "head.h"

int del_char( str )
	char *str ;
{
	while( *str != '\0' )
		if ( *str=='\n' || *str=='\r' || *str==' ' || *str=='\t' ) {
			*str = '\0' ;
			return 0 ;
		} else
			str++ ;

	return 0 ;
}

int chk_para( fn, pps )
	char **fn ;
	PARAMS *pps ;
{
	FILE *fp ;

	pps->para_file = fn[1] ;
	pps->result_file = fn[2] ;

	if ( (fp=fopen(pps->para_file,"r")) == NULL )
		return -1 ;
	else {
		char str[STR_LEN] ;

		if ( fgets( pps->fnl, STR_LEN, fp ) == NULL )
			return -1 ;
		else if ( del_char( pps->fnl ) != 0 )
			return -1 ;

		if ( fgets( pps->fnr, STR_LEN, fp ) == NULL )
			return -1 ;
		else if ( del_char( pps->fnr ) != 0 )
			return -1 ;

		pps->dx		= atoi( fgets( str, STR_LEN, fp ) ) ;
		pps->dy		= atoi( fgets( str, STR_LEN, fp ) ) ;
		pps->dz		= atoi( fgets( str, STR_LEN, fp ) ) ;
		pps->dt		= atoi( fgets( str, STR_LEN, fp ) ) ;

		pps->lx		= atoi( fgets( str, STR_LEN, fp ) ) ;
		pps->ly		= atoi( fgets( str, STR_LEN, fp ) ) ;
		pps->lz_min	= atoi( fgets( str, STR_LEN, fp ) ) ;
		pps->lz_max	= atoi( fgets( str, STR_LEN, fp ) ) ;
		pps->lt		= atoi( fgets( str, STR_LEN, fp ) ) ;

		pps->subpd	= atoi( fgets( str, STR_LEN, fp ) ) ;

		pps->loop	= atoi( fgets( str, STR_LEN, fp ) ) ;
		pps->tintv	= atoi( fgets( str, STR_LEN, fp ) ) ;
		pps->delta	= atof( fgets( str, STR_LEN, fp ) ) ;

		pps->Du		= atof( fgets( str, STR_LEN, fp ) ) ;
		pps->Dv		= atof( fgets( str, STR_LEN, fp ) ) ;

		pps->a0		= atof( fgets( str, STR_LEN, fp ) ) ;
		pps->a1		= atof( fgets( str, STR_LEN, fp ) ) ;
		pps->a2		= atof( fgets( str, STR_LEN, fp ) ) ;
		pps->b		= atof( fgets( str, STR_LEN, fp ) ) ;
		pps->eps	= atof( fgets( str, STR_LEN, fp ) ) ;
		pps->mu_es	= atof( fgets( str, STR_LEN, fp ) ) ;
		pps->mu_ini	= atof( fgets( str, STR_LEN, fp ) ) ;
		pps->tht	= atof( fgets( str, STR_LEN, fp ) ) ;

		pps->sw_u	= atoi( fgets( str, STR_LEN, fp ) ) ;
		pps->sw_v	= atoi( fgets( str, STR_LEN, fp ) ) ;
		pps->sw_ip	= atoi( fgets( str, STR_LEN, fp ) ) ;

		pps->nthr	= atoi( fgets( str, STR_LEN, fp ) ) ;

		/* ------------------------------------------------ */

		pps->xs		= pps->lx ;
		pps->ys		= pps->ly ;
		pps->zs		= (pps->lz_max-pps->lz_min)*pps->subpd+1 ;
		pps->ts		= pps->dt * pps->lt ;
		pps->xys	= pps->xs * pps->ys ;
		pps->xyzs	= pps->xs * pps->ys * pps->zs ;

		pps->Cux	= pps->Du * pps->dx * pps->dx / pps->dt ;
		pps->Cuy	= pps->Du * pps->dy * pps->dy / pps->dt ;
		pps->Cuz	= pps->Du * pps->dz * pps->dz / pps->dt ;

		pps->Cvx	= pps->Dv * pps->dx * pps->dx / pps->dt ;
		pps->Cvy	= pps->Dv * pps->dy * pps->dy / pps->dt ;
		pps->Cvz	= pps->Dv * pps->dz * pps->dz / pps->dt ;

		pps->pu		= 1. + 2.*( pps->Cux + pps->Cuy + pps->Cuz ) ;
		pps->pv 	= 1. + 2.*( pps->Cvx + pps->Cvy + pps->Cvz ) ;

		fclose( fp ) ;
		return 0 ;
	}
}

int free_mem( ps, vs )
	PARAMS ps ;
	VARS vs ;
{
	free( vs.image_left ) ;
	free( vs.image_right ) ;

	free( vs.ou ) ;
	free( vs.ov ) ;
	free( vs.nu ) ;
	free( vs.nv ) ;
	free( vs.du ) ;
	free( vs.dv ) ;

	free( vs.es ) ;
	free( vs.es_sub ) ;

	return 0 ;
}

int all_mem( ps, pvs )
	PARAMS ps ;
	VARS *pvs ;
{
	int xs=ps.xs, ys=ps.ys, zs=ps.zs ;

	pvs->image_left = (unsigned char **)
			an_malloc_2D( xs, ys, sizeof(unsigned char) ) ;
	pvs->image_right = (unsigned char **)
			an_malloc_2D( xs, ys, sizeof(unsigned char) ) ;
	pvs->dpmap = pvs->image_right ;

	pvs->ou = (double ***)an_malloc_3D( xs, ys, zs, sizeof(double) ) ;
	pvs->ov = (double ***)an_malloc_3D( xs, ys, zs, sizeof(double) ) ;
	pvs->nu = (double ***)an_malloc_3D( xs, ys, zs, sizeof(double) ) ;
	pvs->nv = (double ***)an_malloc_3D( xs, ys, zs, sizeof(double) ) ;
	pvs->du = (double ***)an_malloc_3D( xs, ys, zs, sizeof(double) ) ;
	pvs->dv = (double ***)an_malloc_3D( xs, ys, zs, sizeof(double) ) ;

	pvs->es = (float ***)an_malloc_3D( xs, ys, zs, sizeof(float) ) ;
	pvs->es_sub = (float ***)an_malloc_3D( xs, ys, zs, sizeof(float) ) ;

	if (	pvs->image_left==NULL || pvs->image_right==NULL ||
		pvs->ou==NULL || pvs->ov==NULL ||
		pvs->nu==NULL || pvs->nv==NULL ||
		pvs->du==NULL || pvs->dv==NULL ||
		pvs->es==NULL || pvs->es_sub==NULL ) {
		free_mem( ps, *pvs ) ;
		return -1 ;
	} else
		return 0 ;
}

int main( argc, argv )
	int argc ;
	char **argv ;
{
	static PARAMS ps ;
	static VARS vs ;
	int calc() ;

	if ( argc!=3 ) {
		fprintf( stderr, "usage: %s data_file result_file\n", *argv ) ;
		return -1 ;
	} else if ( chk_para( argv, &ps )==-1 ) {
		fputs( "error: in chk_para\n", stderr ) ;
		return -2 ;
	} else if ( all_mem( ps, &vs )==-1 ) {
		fputs( "error: cannot allocate memory\n", stderr ) ;
		return -2 ;
	} else if ( calc( ps, vs )==-1 ) {
		free_mem( ps, vs ) ;
		fputs( "error: cannot calculate\n", stderr ) ;
		return -2 ;
	} else {
		free_mem( ps, vs ) ;
		return 0 ;
	}
}

