#include <stdio.h>
#include <stdlib.h>
#include <an.h>

int main( argc, argv )
	int argc ;
	char **argv ;
{
	AN_IMAGE_COORD img ;
	unsigned char *ucd ;
	FILE *fpi=NULL, *fpo=NULL ;

	if ( argc != 3 ) {
		fprintf( stderr, "usage: %s file file\n", argv[0] ) ;
		return 1 ;
	} else if ( an_get_img( &img ) == -1 ) {
		fputs( "error: cannot get image enviornment\n", stderr ) ;
		return 2 ;
	} else if ( (ucd=(unsigned char *)malloc(img.x*sizeof*ucd)) == NULL ) {
		fputs( "error: cannot allocate memory\n", stderr ) ;
		return 2 ;
	} else if ( (fpi=fopen(argv[1],"rb")) == NULL ||
			(fpo=fopen(argv[2],"wb")) == NULL ) {
		fputs( "error: cannot open file(s)\n", stderr ) ;
		fclose( fpi ) ;
		fclose( fpo ) ;
		free( ucd ) ;
		return 2 ;
	} else {
#		define STR_LEN 512

		int x, y, y0, z, zs, t ;
		char str[STR_LEN] ;
int f ;

		puts( " y=?" ) ;
		y0 = atoi( fgets( str, STR_LEN, stdin ) ) ;

		puts( " zs=?" ) ;
		zs = atoi( fgets( str, STR_LEN, stdin ) ) ;

		for ( t=0; t<img.t; ++t )
			for ( z=0; z<zs; ++z )
			for ( y=0; y<img.y; ++y ) {
				fread( ucd, sizeof*ucd, img.x, fpi ) ;
				if ( y==y0 )
				fwrite( ucd, sizeof*ucd, img.x, fpo ) ;
			}

		fclose( fpi ) ;
		fclose( fpo ) ;
		free( ucd ) ;

		return 0 ;
	}
}

